<?php
//------------------------------------------------------------------------------------
//                                  COPYRIGHT NOTICE
//------------------------------------------------------------------------------------
//LAST POST - FORUMS
//------------------------------------------------------------------------------------
//The included php scripts (code) is the exclusive copyright of EIP Software LLC. 
//(http://www.eipsoftware.com). 
//
//EIP Software LLC grants holder a non-exclusive license and the use of the code is 
//to be used only in connection with the XenForo forum software. Any deviation or 
//violation of EIP Software LLC or XenForo terms of use will immediately 
//revoke any implied or explicitly stated rights granted to you to use the following 
//code.  The code is copyrighted and may not be copied, even if modified or merged 
//with other data or software.
//
//By using the code and XenForo forum software you agree to be bound by EIP 
//Software LLC's and XenForo Terms of Service as well as these 
//additional terms and conditions. 
//
//XenForo forum software's use of any kind of part or all of XenForo
//software requires a separate license from XenForo. You may not 
//commercially redistribute and or part of LAST POST - FORUMS or XenForo's forum
//software.
//
//This code is distributed in the hope that it will be useful, but WITHOUT ANY 
//WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
//PARTICULAR PURPOSE. завершенный!
//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
//cls_runqry.php:    	run a qry agains the dbase
//called by:            
//inputs:               NONE     
//uses:                 NONE        
//returns:
//outputs:              class
//updates:              2009-01-13 :: mm :: original
//						2010-01-14 :: mm :: change fx __construct to allow for different levels
//------------------------------------------------------------------------------------
//version:              1.01
//status:               CHECKED IN
//------------------------------------------------------------------------------------
class eipRunQuery
{
	private	$lp;							//new linepatch
	private $hnd_DB;						//handle to the database
	private $sel_DB;						//selection to the database
	private $str_Level;						//level
	private $sqlQry;						//usr submitted query
	private $bol_Success		= false;	//did the query run successfully
	private $bol_SuppressErr 	= false;	//suppress run time errors
	public	$arr_SQLData		= Array();	//array holding results from the sql query
	
	public function SetSuppressErrors($bol_Value){$this->bol_SuppressErr=$bol_Value;}
	
	public function __construct($useroptions)
	{
		$this->lp = new eipLastPostxfconfig($useroptions['forumDirectory']);
	}
	public function __destruct()
	{
		mysql_close($this->hnd_DB);									//close the connection
	}
	
	private function ConnectDB()
	{
		try
        {
			if((!$this->hnd_DB) || (!$this->sel_DB))
			{
				$this->hnd_DB = mysql_connect($this->lp->getValue("db","host"), $this->lp->getValue("db","username"), $this->lp->getValue("db","password"));
	        		if(!$this->hnd_DB){throw new ExceptionHandler("The database is currently not available");}
	        	$this->sel_DB = mysql_select_db($this->lp->getValue("db","dbname"),$this->hnd_DB);
	        		if(!$this->sel_DB){throw new ExceptionHandler("The database connection is currently not available");}
	        	//mysql_query("SET NAMES utf8");
	        	mysql_set_charset('utf8', $this->hnd_DB);
			}
        }
		catch(ExceptionHandler $e)
        {
            $e->ParseError("The database connection failed.<br/>");
        }		
	}
		
	private function ProcessQuery()
	{
		try
		{
			$this->ConnectDB();
			$sql_result = mysql_query($this->sqlQry, $this->hnd_DB);			//run the query
			if(!$sql_result && !$this->bol_SuppressErr){throw new ExceptionHandler($this->sqlQry);}//if the qry is null something is wrong
			if($sql_result)												//if we have a valid result
			{
				switch($this->qryType)									//what type of query is the usr running
				{
					case "SELECT":										//select will pop the number of rows for them
					{
						while($row = mysql_fetch_assoc($sql_result))	//cycle through the qry to make sure everything is ok
						{
							array_push($this->arr_SQLData,$row);		//push the data into the array	
						}
						break;
					}
					case "UPDATE":
					{
						$this->bol_Success = true;						//the query ran successfully
						break;
					}
					mysql_free_result($sql_result);  					//clear the results
				}
			}

	    }
	    catch(ExceptionHandler $e)
	    {
	        $e->ParseError("Error during the query processing. <br/>" .$this->sqlQry);
	    }		
	}

	public function getQueryResults($qry,$qryType="select",$str_Level="READ")
	{
		try
		{
			unset($this->arr_SQLData);
			$this->arr_SQLData	= Array(); 
			$this->qryType 		= strtoupper($qryType);
			$this->str_Level	= strtoupper($str_Level);
			$this->sqlQry		= $qry;						//sterilize
			$this->ProcessQuery();							//run the query
			
			if($this->qryType == "SELECT")
			{
				return($this->arr_SQLData);			//return the array full of data
			}
			else
			{
				return($this->bol_Success);			//return if the qry was successful
			}
		}
		catch(ExceptionHandler $e)
	    {
	        $e->ParseError("Error during the query results. <br/>".$qry);
	    }		
	}
}
?>
