<?php
/*
Plugin Name: eipSoftware Get Latest Posts
Plugin URI: http://www.eipsoftware.com/
Description: Get X number of last posts from Xenforo forum software
Author: eipSoftware
Version: 1.1.0
Author URI: http://www.eipsoftware.com/
*/
/** 
 * @package Get_Forum_Last_Post
 * @name Get Forum Last Post
 * @copyright eipSoftware LLC
 * @author eipSoftware LLC  http://www.eipsoftware.com
 * @version 1.1.0
------------------------------------------------------------------------------------
                                  COPYRIGHT NOTICE
------------------------------------------------------------------------------------
LAST POST - FORUMS
------------------------------------------------------------------------------------
The included php scripts (code) is the exclusive copyright of EIP Software LLC. 
(http//:www.eipsoftware.com). 

EIP Software LLC grants holder a non-exclusive license and the use of the code is 
to be used only in connection with the XenForo forum software. Any deviation or 
violation of EIP Software LLC or XenForo terms of use will immediately 
revoke any implied or explicitly stated rights granted to you to use the following 
code.  The code is copyrighted and may not be copied, even if modified or merged 
with other data or software.

By using the code and XenForo forum software you agree to be bound by EIP 
Software LLC's and XenForo Terms of Service as well as these 
additional terms and conditions. 

XenForo forum software's use of any kind of part or all of XenForo
software requires a separate license from XenForo. You may not 
commercially redistribute and or part of LAST POST - FORUMS or XenForo's forum
software.

This code is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. завершенный!
------------------------------------------------------------------------------------

------------------------------------------------------------------------------------
 */
// Make sure file isn't being called directly.
if (!function_exists('add_action')) 
{
	echo("This is the Get Forum Last Post plugin for wordpress; use the wordpress plugin manager to update the options");
	exit;
}
if(is_admin())
{
	require_once dirname( __FILE__ ) . '/getForumLastPostAdmin.php';
}

//store the action in the queue
add_action("plugins_loaded", "eipLastPostsRegister");
add_action('wp_print_styles', 'addLastPostStyle');	
	/**
	 * 
	 * initialize and register the widget
	 */
	function eipLastPostsRegister()
	{
		wp_register_sidebar_widget("eipGLP", "eip Last Posts","eipGetLastPosts");
		//wp_register_widget_control("eipGLP", "eip Last Posts Widget", "eipGetLastPosts_control", 500,400);
	}
	function addLastPostStyle()
	{
		wp_register_style("eipGLPStyle", WP_PLUGIN_URL . "/eipSoftwareLastPost/styles/style_lastpost.css");
		wp_enqueue_style("eipGLPStyle", dirname(__FILE__) ."/styles/style_lastpost.css", false, '1.1', 'all' ); // Inside a plugin
	}
	function eipGetLastPosts()
	{
		$curr_dir = dirname( __FILE__ );
		include_once $curr_dir . '/cls/cls_errorhandler.php';
		include_once $curr_dir . '/cls/cls_getlastposts.php';
		include_once $curr_dir . '/cls/cls_xfconfig.php';
		include_once $curr_dir . '/cls/cls_htmlelements.php';
		include_once $curr_dir . '/qry/qry_privatenodelist.php';
		include_once $curr_dir . '/qry/qry_lastposts.php';
		$lastPosts = new getLastPosts;
		echo($lastPosts->getForumData());
		unset($lastPosts);
	}
	function eipGetLastPosts_control()
	{
		return;
	}
?>